// simple.vert

#version 120
#extension GL_EXT_gpu_shader4 : enable
//#extension GL_ARB_explicit_attrib_location : enable

uniform int lightNumber;
uniform float scatter;

attribute float pointSize;
attribute int subIndex;

varying vec3  positionIn;
varying float pointSizeIn;
varying int   subIndexIn;

varying vec3 viewVecIn;
varying vec3 normalIn;
varying vec3 binormalIn;
varying vec3 tangentIn;

void main(void)
{
    gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
    gl_FrontColor = gl_Color;
    gl_TexCoord[0] = gl_MultiTexCoord0;
    pointSizeIn = pointSize;
    positionIn = vec3(gl_ModelViewMatrix * gl_Vertex);
    subIndexIn = subIndex;

    vec3 position = vec3(gl_ModelViewMatrix * gl_Vertex);

    viewVecIn = -normalize(position);

    normalIn = vec3(0,0,1);
    binormalIn = vec3(0,1,0);
    tangentIn = vec3(1,0,0);
}

