#version 120
#extension GL_EXT_gpu_shader3 : enable

attribute float pointSize;
//uniform vec2 screenSize;
uniform vec4 viewport;
uniform float baseDistance;
uniform int dissolveMode;

varying vec4 position;
varying vec2 center;
varying float radiusFactor;
varying float radius;

varying vec2 ensembleParamA;
varying float ensembleParamB;

void main(void)
{
    position = gl_ModelViewMatrix * gl_Vertex;
    gl_FrontColor = gl_Color;

    gl_Position = ftransform();

    float xydistance = sqrt(gl_Position.x * gl_Position.x + gl_Position.y * gl_Position.y);
    float theta = atan(xydistance/gl_Position.w);
    
    float factor = cos(theta);
    radiusFactor = factor;
    
    if (baseDistance != 0){
	gl_PointSize = pointSize / gl_Position.w * baseDistance / factor;
	radius = pointSize / gl_Position.w / 2 * baseDistance / factor;
    }
    else{
	gl_PointSize = pointSize / factor;
	radius = pointSize / 2 / factor;
    }
    
    //center = (screenSize + ( ( gl_Position.xy / gl_Position.w ) * screenSize )) / 2;

    //vec2 viewTmp = vec2(viewport[2], viewport[3]);
    //center = (viewTmp + ( ( gl_Position.xy / gl_Position.w ) * viewTmp )) / 2;
    
    center = vec2((gl_Position.x / gl_Position.w * viewport[2] + viewport[2])/2 + viewport[0],
		  (gl_Position.y / gl_Position.w * viewport[3] + viewport[3])/2 + viewport[1]);


}
