
#version 120
#extension GL_EXT_gpu_shader4 : enable

uniform sampler2D textureImage;
uniform int fogMode;
uniform int dissolveMode;
uniform int lightNumber;
uniform float clipThreshold;

uniform vec2 ensembleParamA;
uniform float ensembleParamB;
uniform vec2 ensembleParamC;

uniform float projInv11;
uniform float projInv15;

varying vec3 position;
varying vec3 normal;
varying vec4 diffuseAndAmbient;

//##FUNC_SMOOTHCLIPPING##

//##FUNC_ENSEMBLE_DITHERING##

//##FUNC_FOG_EFFECT##

void main (void)
{
    vec4 texColor = texture2D(textureImage, gl_TexCoord[0].st);
    if (texColor[3] < clipThreshold) discard;

    texColor[0] += 0.0001;
    texColor[1] += 0.0001;
    texColor[2] += 0.0001;
    
    gl_FragColor = texColor * gl_Color * diffuseAndAmbient;
    float alpha = gl_FragColor[3];

    //##APPLY_SMOOTHCLIPPING##

    //##APPLY_ENSEMBLE_DITHERING##
    if (alpha > 1.0){ 
	gl_FragColor[0] *= alpha;
	gl_FragColor[1] *= alpha;
	gl_FragColor[2] *= alpha; 
	alpha = 1.0;
    }

    //##APPLY_FOG_EFFECT##
    
    gl_FragColor[3] = alpha;
}
